﻿using AliGenieAssistantWinUI3;
using System;
using System.Collections.Generic;
using System.Management.Automation;

namespace AliGenieAssistant
{
    internal class AppHelper
    {
        private static AppHelper instance;

        private Dictionary<String, String> appList = new Dictionary<string, string>();
        private AppHelper()
        {
            // 改进方法，使用PowerShell的get-startapps方法
            PowerShell ps = PowerShell.Create();
            ps.AddCommand("Set-ExecutionPolicy")
                .AddParameter("Scope", "Process")
                .AddParameter("ExecutionPolicy", "Bypass")
                .Invoke();
            ps.AddScript("Get-StartApps");
            ICollection<PSObject> outputs = ps.Invoke();
            foreach (PSObject output in outputs)
            {
                String name = (string)output.Members["Name"].Value;
                if (appList.ContainsKey(name.ToLower()))
                {
                    continue;
                }
                appList.Add(name.ToLower(), (string)output.Members["AppID"].Value);
            }
        }

        public static AppHelper getInstance() { 
            if (instance is null)
            {
                instance = new AppHelper();
            }
            return instance; 
        }

        public void controlApp(Operator opt)
        {
            if(opt.intentName.Equals("打开"))
            {
                String app = opt.slotValue;
                if ("浏览器".Equals(app))
                {
                    System.Diagnostics.Process.Start("explorer.exe", "http://cn.bing.com/");
                    return;
                }
                if ("谷歌".Equals(app))
                {
                    System.Diagnostics.Process.Start("explorer.exe", "https://www.google.com.hk/");
                    return;
                }
                if ("百度".Equals(app))
                {
                    System.Diagnostics.Process.Start("explorer.exe", "https://www.baidu.com/");
                    return;
                }
                if("aom".Equals(app))
                {
                    System.Diagnostics.Process.Start("explorer.exe", "https://aom.awebide.com/");
                    return;
                }
                if ("邮箱".Equals(app))
                {
                    //先查下有没有Outlook,outlook优先，没有就系统的邮件应用
                    if (appList.ContainsKey("outlook"))
                    {
                        app = "outlook";
                    }
                    else
                    {
                        app = "邮件";
                    }
                }
                if (appList.ContainsKey(app.ToLower()))
                {
                    String aumid = appList[app.ToLower()];
                    LoggerHelper.Instance().AddLog("查询到应用aumID:" + aumid);
                    String script = "shell:appsfolder\\" + aumid;
                    Console.WriteLine(script);
                    System.Diagnostics.Process.Start("explorer.exe", script);
                }
                else
                {
                    LoggerHelper.Instance().AddLog("本机未装有应用:" + app);
                    foreach (string key in appList.Keys)
                    {
                        if (key.Contains(app.ToLower()))
                        {
                            LoggerHelper.Instance().AddLog("查找到最匹配应用:" + key);
                            string aumid = appList[key.ToLower()];
                            LoggerHelper.Instance().AddLog("查询到应用aumID:" + aumid);
                            String script = "shell:appsfolder\\" + aumid;
                            Console.WriteLine(script);
                            System.Diagnostics.Process.Start("explorer.exe", script);
                        }
                    }
                }
                
            }
        }

    }
}
