﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace AliGenieAssistantWinUI3
{
    class LoggerHelper
    {
        public ObservableCollection<LogItem> LogSource = new ObservableCollection<LogItem>();

        private static LoggerHelper s_instance = null;

        SynchronizationContext _syncContext = null;

        private LoggerHelper() {
            _syncContext = SynchronizationContext.Current;
        }

        public static LoggerHelper Instance()
        {
            if (s_instance == null)
            {
                s_instance = new LoggerHelper();
            }
            return s_instance;
        }
        
        private void addLogItem(Object item)
        {
            LogSource.Add((LogItem)item);
        }
        public void AddLog(string logMsg)
        {
            DateTime now = DateTime.Now;
            string date = now.ToString("yyyy-MM-dd");
            string time = now.ToString("HH:mm:ss");
            LogItem item = new(date, time, logMsg);
            _syncContext.Post(addLogItem, item);
        }

        public void ClearLog()
        {
            LogSource.Clear();
        }
    }

    
}
