﻿using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;
using Microsoft.UI.Xaml.Data;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;
using Microsoft.UI.Xaml.Navigation;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading;
using Windows.Foundation;
using Windows.Foundation.Collections;

// To learn more about WinUI, the WinUI project structure,
// and more about our project templates, see: http://aka.ms/winui-project-info.

namespace AliGenieAssistantWinUI3
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class SettingPage : Page
    {
        public SettingPage()
        {
            this.InitializeComponent();
            initValue();
        }

        private void initValue()
        {
            String ip = MQTTHelper.Instance().ip;
            int port = MQTTHelper.Instance().port;
            this.connectUrlText.Text = ip;
            this.connectPortText.Value= port;
        }

        private void connectUrlText_TextChanged(object sender, TextChangedEventArgs e)
        {
            configChange();
        }

        private void connectPortText_ValueChanged(NumberBox sender, NumberBoxValueChangedEventArgs args)
        {
            configChange();
        }

        private void configChange()
        {
            string new_ip = this.connectUrlText.Text;
            int new_port = (int)this.connectPortText.Value;
            MQTTHelper.Instance().ChangeConfig(new_ip, new_port);
        }

        private void resetButton_Click(object sender, RoutedEventArgs e)
        {
            _ = MQTTHelper.Instance().Reset();
        }
    }
}
